/****************************************************************
 * grl-agent.cpp													*
 *																*
 * This is a customized version of the boilerplate for compiled	*
 * GRL programs. It serves as a convenient interface for		*
 * FlexBot behavior development regardless of whether the GRL	*
 * language is used in development.	It should not be necessary 	*
 * to modify this file in order to develop a FlexBot behavior.	*
 ****************************************************************/

#include "grl-agent.h"

grl_agent::grl_agent() {
  old_clock_valid = false;
  
  // Give the actuators default values
  rotate = 0;
  translate = 0;
  strafe = 0;
  pitch = 0;
  shoot = false;
  duck = false;
  jump = false;
  secondary = false;
  weapon = false;
  reload = false;
  use = false;
}

void grl_agent::update_grl_timeB() {
  if (old_clock_valid)
    measured_clock_period = ms_clock-old_ms_clock;
  old_ms_clock = ms_clock;
  old_clock_valid = true;   
}

void grl_agent::before_signal_update() {
}

void grl_agent::after_signal_update() {
}

/*****************************************************
 * FLEX-BOT ACTUATORS								 *
 *****************************************************/
void grl_agent::do_rotation(int speed)
{
	rotate = speed;
}

void grl_agent::do_translation(int speed)
{
	translate = speed;
}

void grl_agent::do_strafe(int speed)
{
	strafe = speed;
}

void grl_agent::do_pitch(int speed)
{
	pitch = speed;
}

void grl_agent::do_shoot(bool do_it)
{
	shoot = do_it;
}

void grl_agent::do_duck(bool do_it)
{
	duck = do_it;
}

void grl_agent::do_jump(bool do_it)
{
	jump = do_it;
}
void grl_agent::do_secondary(bool do_it)
{
	secondary = do_it;
}
void grl_agent::do_weapon(int do_it)
{
	weapon = do_it;
}
void grl_agent::do_reload(bool do_it)
{
	reload = do_it;
}
void grl_agent::do_use(bool do_it)
{
	use = do_it;
}