/****************************************************************
 * grl-math.h													*
 *																*
 * This is a file that is required for those developing			*
 * FlexBot behaviors using compiled GRL code. The file is not	*
 * required for any other users.								*
 ****************************************************************/

//
// GRL-SPECIFIC MATH DEFINTIONS FOR C++
//

//
// Make abs() polymorphic (and inlined)
//

static inline float abs(float x) {
  if (x>=0)
    return x;
  else
    return -x;
}

// This doesn't seem to interfere with the definition in math.h
static inline int abs(int x) {
  if (x>=0)
    return x;
  else
    return -x;
}

//
// Hacks to implement the division semantics of Scheme.
//

static inline int quotient(int a, int b) {
  return a/b;
}

static inline float fdiv(float a, float b) {
  return a/b;
}

static inline double fdiv(double a, double b) {
  return a/b;
}

//
// The GRL round->integer function
//

static inline int round_GTinteger(float a) {
  return (int)(a+0.5);
}

static inline int round_GTinteger(double a) {
  return (int)(a+0.5);
}

